#include <fstream>
#include <iostream>
#include <stdlib.h>
using namespace std;

const int MAXL = 100;
const int MAXS = 100;
const int MAXO = 100;

struct Centralina {
  int id;
  float x;
  float y;
  char nome[MAXL];
};

struct Rilevamento {
  float pm10;
  float pm5;
  int centId;
};

struct SistemaInq {
  Centralina cent[MAXS];
  int numCent;
  Rilevamento ril[MAXO];
  int numRil;
};

bool carica(SistemaInq* psi, const char nomef[]) ;
bool inserisciRil(SistemaInq* psi, Rilevamento o) ;
bool maxPm10AndPm5(const SistemaInq* psi, float* ppm10, float* ppm5) ;
void eliminaRil(SistemaInq* psi, int sid) ;
int piuVicine(const SistemaInq* psi, Centralina s, Centralina vett[]) ;

void stampaCent(Centralina s) {
  cout << "Nome: " << s.nome << " x: " << s.x << " y: " << s.y << " id: " << s.id << endl;
}

void stampaRil(Rilevamento o) {
  cout << "centId: " << o.centId << " pm10: " << o.pm10 << " pm5: " << o.pm5<< endl; 
}

void stampaSI(const SistemaInq* psi) {
  cout << "Centraline:" << endl;
  for(int i=0; i<psi->numCent; i++)
    stampaCent(psi->cent[i]);
  cout << "Rilevamenti:" << endl;
  for(int i=0; i<psi->numRil; i++)
    stampaRil(psi->ril[i]);
}

int main(){
  SistemaInq sm;
  sm.numCent = 0;
  sm.numRil  = 0;


  cout << "Provo la funzione carica():" << endl;
  bool res = carica(&sm, "elenco.txt");
  if(res) cout << "Caricamento eseguito" << endl;
  else cout << "Problemi durante il caricamento" << endl;
  cout << "Contenuto del sistema inq.:" << endl;
  stampaSI(&sm);
  system("pause");

  cout << "Provo la funzione inserisciRil()" << endl;
  Rilevamento o;
  o.pm10 = 32.4f;
  o.pm5 = 23.4f;
  o.centId = 1;
  res = inserisciRil(&sm, o);
  if(res) cout << "Inserimento ok" << endl;
  else cout << "Errore (sistema pieno o centralina corrispondente non presente)" << endl;
  o.pm10 = 31.4f;
  o.pm5 = 34.1f;
  o.centId = 2;
  res = inserisciRil(&sm, o);
  if(res) cout << "Inserimento ok" << endl;
  else cout << "Errore (sistema pieno o centralina corrispondente non presente)" << endl;
  o.pm10 = 26.4f;
  o.pm5 = 31.1f;
  o.centId = 3;
  res = inserisciRil(&sm, o);
  if(res) cout << "Inserimento ok" << endl;
  else cout << "Errore (sistema pieno o centralina corrispondente non presente)" << endl;
  o.pm10 = 23.7f;
  o.pm5 = 22.8f;
  o.centId = 5;
  res = inserisciRil(&sm, o);
  if(res) cout << "Inserimento ok" << endl;
  else cout << "Errore (sistema pieno o centralina corrispondente non presente)" << endl;
  o.pm10 = 28.2f;
  o.pm5 = 25.8f;
  o.centId = 2;
  res = inserisciRil(&sm, o);
  if(res) cout << "Inserimento ok" << endl;
  else cout << "Errore (sistema pieno o centralina corrispondente non presente)" << endl;
  o.pm10 = 24.5f;
  o.pm5 = 35.3f;
  o.centId = 9;
  res = inserisciRil(&sm, o);
  if(res) cout << "Inserimento ok" << endl;
  else cout << "Errore (sistema pieno o centralina corrispondente non presente)" << endl;
  cout << "Contenuto del sistema inq.:" << endl;
  stampaSI(&sm);
  system("pause");

  float maxp, maxt;
  cout << "Provo maxPm10AndPm5()" << endl;
  res = maxPm10AndPm5(&sm, &maxp, &maxt);
  if(res) cout << "Max pm10: " << maxp << " Max pm5: " << maxt << endl;
  else cout << "Non ci sono rilervazioni" << endl;
  system("pause");

  cout << "Provo eliminaRil()" << endl;
  eliminaRil(&sm, 2);  
  cout << "Contenuto del sistema inq:" << endl;
  stampaSI(&sm);
  system("pause");

  cout << "Provo piuVicine()" << endl;
  Centralina s = sm.cent[0];
  cout << "relativamente alla centralina " << s.nome << endl;
  Centralina tmp[MAXS];
  int k = piuVicine(&sm, s, tmp);
  cout << "Le centraline piu' vicine sono:" << endl;
  for(int i=0; i<k; i++)
    stampaCent(tmp[i]); 
  system("pause");

  return 0; 
}
