#include <fstream>
#include <math.h>
using namespace std;

const int MAXL = 100;
const int MAXS = 100;
const int MAXO = 100;

struct Centralina {
  int id;
  float x;
  float y;
  char nome[MAXL];
};

struct Rilevamento {
  float pm10;
  float pm5;
  int centId;
};

struct SistemaInq {
  Centralina cent[MAXS];
  int numCent;
  Rilevamento ril[MAXO];
  int numRil;
};

bool carica(SistemaInq* psi, const char nomef[]) {
  fstream ff;
  ff.open(nomef, ios::in);
  if(!ff) 
    return false;
  while(ff >> psi->cent[psi->numCent].nome >> psi->cent[psi->numCent].x >> psi->cent[psi->numCent].y >> psi->cent[psi->numCent].id)
    psi->numCent++;
  return true;
}

bool inserisciRil(SistemaInq* psi, Rilevamento o) {
  bool trovata = false;
  for(int i=0; i<psi->numCent; i++)
    if(psi->cent[i].id == o.centId)
      trovata = true;
  if(!trovata || psi->numRil == MAXO)
    return false;
  psi->ril[psi->numRil] = o;
  psi->numRil++;
  return true; 
}

void eliminaRil(SistemaInq* psi, int sid){
  for(int index = 0; index<psi->numRil; index++) {
    if(psi->ril[index].centId == sid) {
      psi->ril[index] = psi->ril[--psi->numRil];
      index--;
    }
  }
}

bool maxPm10AndPm5(const SistemaInq* psi, float* ppm10, float* ppm5) {
  float mp = 0.0f, mt = 0.0f;
  if(psi->numRil==0)
    return false;
  for(int i=0; i<psi->numRil; i++) {
    if(psi->ril[i].pm10 > mp)
      mp = psi->ril[i].pm10;
    if(psi->ril[i].pm5 > mt)
      mt = psi->ril[i].pm5;
  }
  *ppm10 = mp;
  *ppm5 = mt;
  return true;
}

float distanza(float x1, float y1, float x2, float y2) {
  return sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
}

void ordina(Centralina v[], int n, Centralina s) {
  for(int i=0; i<n-1; i++){
    int minindex = i;
    for(int j=i+1; j<n; j++)
      if(distanza(s.x, s.y, v[j].x, v[j].y) < distanza(s.x, s.y, v[minindex].x, v[minindex].y))
        minindex = j;
    Centralina aux = v[i];
    v[i] = v[minindex];
    v[minindex] = aux;
  }
}

int piuVicine(const SistemaInq* psm, Centralina s, Centralina vett[]) {
  Centralina temp[MAXS];
  int conta = 0;
  for(int i=0; i<psm->numCent; i++)
    if(psm->cent[i].id != s.id)
      temp[conta++] = psm->cent[i];
  ordina(temp, conta, s);
  int k = 3;  
  k = k<conta ? k : conta; 
  for(int i=0; i<k; i++)
    vett[i] = temp[i];
  return k;
}
